#===============================================================================
# Copyright 2014-2017 Intel Corporation All Rights Reserved.
#
# The source code,  information  and material  ("Material") contained  herein is
# owned by Intel Corporation or its  suppliers or licensors,  and  title to such
# Material remains with Intel  Corporation or its  suppliers or  licensors.  The
# Material  contains  proprietary  information  of  Intel or  its suppliers  and
# licensors.  The Material is protected by  worldwide copyright  laws and treaty
# provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
# modified, published,  uploaded, posted, transmitted,  distributed or disclosed
# in any way without Intel's prior express written permission.  No license under
# any patent,  copyright or other  intellectual property rights  in the Material
# is granted to  or  conferred  upon  you,  either   expressly,  by implication,
# inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
# property rights must be express and approved by Intel in writing.
#
# Unless otherwise agreed by Intel in writing,  you may not remove or alter this
# notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
# suppliers or licensors in any way.
#===============================================================================

## <a name="DAAL-EXAMPLE-PY-PCA_CORRELATION_CSR_DISTRIBUTED"></a>
## \example pca_cor_csr_distr.py

from os import environ
from os.path import join as jp

from daal.algorithms.pca import (
    Distributed_Step2MasterFloat64CorrelationDense, eigenvectors,
    Distributed_Step1LocalFloat64CorrelationDense,
    data, partialResults, eigenvalues,
)
from daal.algorithms.covariance import (
    Distributed_Step1LocalFloat64FastCSR, Distributed_Step2MasterFloat64FastCSR
)
import inspect, sys, os.path
utils_folder = os.path.realpath(os.path.abspath(jp(os.path.split(inspect.getfile(inspect.currentframe()))[0], "..")))
if utils_folder not in sys.path:
    sys.path.insert(0, utils_folder)
from utils import printNumericTable, createSparseTable

DAAL_PREFIX = jp('..', 'data')

# Input data set parameters
nBlocks = 4
datasetFileNames = [
    jp(DAAL_PREFIX, 'distributed', 'covcormoments_csr_1.csv'),
    jp(DAAL_PREFIX, 'distributed', 'covcormoments_csr_2.csv'),
    jp(DAAL_PREFIX, 'distributed', 'covcormoments_csr_3.csv'),
    jp(DAAL_PREFIX, 'distributed', 'covcormoments_csr_4.csv')
]

if __name__ == "__main__":

    # Create an algorithm for principal component analysis using the correlation method on the master node
    masterAlgorithm = Distributed_Step2MasterFloat64CorrelationDense()

    for i in range(nBlocks):
        dataTable = createSparseTable(datasetFileNames[i])

        # Create algorithm objects to compute a variance-covariance matrix in the distributed processing mode using the default method
        localAlgorithm = Distributed_Step1LocalFloat64CorrelationDense()

        # Create an algorithm for principal component analysis using the correlation method on the local node
        localAlgorithm.parameter.covariance = Distributed_Step1LocalFloat64FastCSR()

        # Set input objects for the algorithm
        localAlgorithm.input.setDataset(data, dataTable)

        # Compute partial estimates on local nodes
        # Set local partial results as input for the master-node algorithm
        masterAlgorithm.input.add(partialResults, localAlgorithm.compute())

    # Use covariance algorithm for sparse data inside the PCA algorithm
    masterAlgorithm.parameter.covariance = Distributed_Step2MasterFloat64FastCSR()

    # Merge and finalize PCA decomposition on the master node
    masterAlgorithm.compute()

    result = masterAlgorithm.finalizeCompute()

    # Print the results
    printNumericTable(result.get(eigenvalues), "Eigenvalues:")
    printNumericTable(result.get(eigenvectors), "Eigenvectors:")
